local mod = RW:Boss("Twin Val'Kyrs", "Trial of the Crusader", "Crusaders Coliseum")
local L

-- Switch to light essence even tho light essence was on

local tSpecial
local tDVortexCast, tLVortexCast
local tDVortexDur, tLVortexDur
local tDPactCast, tLPactCast

local wInterrupt
local wShield, wDark, wLight
local wChangeTarget
local wSpecial

local mInteruppt, mSpcial

function mod:OnRegister()
	L = self:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Faction Champions"
		
		L.YellVictory = "A shallow and tragic victory. We are weaker as a whole from the losses suffered today. Who but the Lich King could benefit from such foolishness? Great warriors have lost their lives. And for what? The true threat looms ahead - the Lich King awaits us all in death."
		
		L.healthframes = "Shield health frames"
		
		L.change_essence_opt = "Change essence warning"
		L.change_essence = "Change to %s!"
		L.change_essence_light = "Change to Light"
		L.change_essence_dark = "Change to Dark"
		
		L.interrupt = "Interrupt!"
		L.interrupt_opt = "When interrupt is possible"
		L.shield_warning = "Shield on other target, switch!"
		L.shield_warning_opt = "Shield on other twin"
		
		L.next_special = "Next Special: (%s)"
		L.next_special_pre_msg = "Special in 10s (%s)!"
		L.next_special_pre_msg_opt = "10s message for next special"
		L.next_special_pre_warn_opt = "10s warning for next special"
		L.next_speical_opt = "Timer for next special"
		L.next_special_opt2 = "Next special countdown"
		
		L.interrupted_msg = "Heal interrupted by >%s<!"
		L.change_target = "%s up, change target!"
		L_change_target_opt = "Warning for shiled up on off target"
	end	
	L = self:GetLocale()
	mod.L = L
	
	mod:SetTrigger(34497, 34496)
	mod:SetWin(34497)
	
	self:AddBoolOption("HealthFrames", L.healthframes)
	
	tSpecial = self:CustomTimer(45, {L.next_special, L.next_special_opt2}, 26090, L.next_speical_opt)
	
	tDVortexCast, tLVortexCast 	= self:CastTimer(67183), self:CastTimer(67207)
	tDVortexDur, tLVortexDur 	= self:DurTimer(5, 67183), self:DurTimer(5, 67207)
	tDPactCast, tLPactCast 		= self:CastTimer(65875), self:CastTimer(65876)
	
	wDark, wLight 	= self:CustomWarning({L.change_essence, L.change_essence_dark}, 67176, L.change_essence_opt), self:CustomWarning({L.change_essence, L.change_essence_light}, 67223, L.change_essence_opt)
	wShield 		= self:CustomWarning({L.shield_warning, L.shield_warning_opt}, 65876)
	wInterrupt 		= self:CustomWarning({L.interrupt, L.interrupt_opt}, 6552, 65876)
	wSpecial		= self:CustomWarning({L.next_special_pre_msg, L.next_special_pre_warn_opt}, 26090, L.next_speical_opt, false)
	
	mInteruppt 	= self:CustomMessage({L.interrupted_msg, "Report who interrupted"}, 65876)
	mSpecial	= self:CustomMessage({L.next_special_pre_msg, L.next_special_pre_msg_opt}, 26090, L.next_speical_opt)
end

local DarkEssence = GetSpellInfo(67176)
local LightEssence = GetSpellInfo(67223)
local casting
local canInterrupt = (mod.pClass == "DEATHKNIGHT" or mod.pClass == "ROGUE" or mod.pClass == "WARRIOR" or mod.pClass == "MAGE")
local SpecialRotation

local function UseSpecial(spStr)
	for i, _ in pairs(SpecialRotation) do
		if SpecialRotation[i] == spStr then
			table.remove(SpecialRotation, i)
			break
		end
	end
	if #SpecialRotation == 0 then
		SpecialRotation = {"DS", "LS", "DV", "LV"}
	end
end

local function ResetCasting() casting = "" end

local showShieldHealthBar, hideShieldHealthBar
do
	local frame = CreateFrame("Frame") 
	local shieldedMob
	local absorbRemaining = 0
	local maxAbsorb = 0
	local function getShieldHP()
		return math.max(0, absorbRemaining / maxAbsorb )
	end
	frame:SetScript("OnEvent", function(self, event, timestamp, subEvent, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
		if shieldedMob == destGUID then
			local absorbed
			if subEvent == "SPELL_MISSED" or subEvent == "SPELL_PERIODIC_MISSED" then
				absorbed = select(5, ...)
			elseif subEvent == "SWING_MISSED" then
				absorbed = select(2, ...)
			elseif subEvent == "RANGE_MISSED" then
				absorbed = select(5, ...)
			end
			if absorbed then
				absorbRemaining = absorbRemaining - absorbed
			end
		end
	end)
	
	function showShieldHealthBar(mob, shieldName)
		shieldedMob = mob
		absorbRemaining = 	GetInstanceDifficulty() == 4 and 1200000 or
							GetInstanceDifficulty() == 3 and 700000 or
							GetInstanceDifficulty() == 2 and 300000 or
							GetInstanceDifficulty() == 1 and 175000 or 0
		maxAbsorb = absorbRemaining
		mod:SendMessage("RW_RemoveAllHealthFrames")
		mod:SendMessage("RW_AddHealthFrame", getShieldHP, shieldName)
		mod:ScheduleTimer(hideShieldHealthBar, 15)
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
	
	function hideShieldHealthBar()
		mod:SendMessage("RW_RemoveAllHealthFrames")
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
	
	function mod:TestHealth()
		frame:GetScript("OnEvent")(frame, "COMBAT_LOG_EVENT_UNFILTERED", 1, "SWING_DAMAGE", sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, nil, nil, nil, nil, nil, 5000)
	end
end

function mod:OnEngage()
	self:Track("DarkVortex", 67182, 67184, 66058, 67183)
	self:Track("LightVortex", 67206, 67208, 66046, 67207)
	self:Track("DarkPact", 65876, 67306, 67307, 67308)
	self:Track("LightPact", 65875, 67303, 67304, 67305)
	self:Track("DarkShield", 67257, 67258, 65874, 67256)
	self:Track("LightShield", 67260, 67261, 65858, 67259)
	self:Track("DarkTouch", 67283, 66001, 67281, 67282)
	self:Track("LightTouch", 67298, 65950, 67296, 67297)
	
	casting = ""
	SpecialRotation = {"DS", "LS", "DV", "LV"}
	
	tSpecial:Start(table.concat(SpecialRotation, ", "))
	mSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
	wSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
end

function mod:DarkVortex(event, args)
	if event == "SPELL_CAST_START" then
		local changeEssence = UnitDebuff("player", LightEssence)
		if changeEssence or true then
			wDark:Show(DarkEssence)
		end
		tDVortexCast:Start(self:IsHeroic() and 6 or 8)
		tDVortexDur:Schedule(self:IsHeroic() and 6.01 or 8.01)
		UseSpecial("DV")
		tSpecial:Start(table.concat(SpecialRotation, ", "))
		mSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		wSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		casting = "DarkVortex"
		self:Schedule("CastReset", 12, ResetCasting)
	end
end
function mod:LightVortex(event, args)
	if event == "SPELL_CAST_START" then
		local changeEssence = UnitDebuff("player", DarkEssence)
		if changeEssence or true then
			wLight:Show(LightEssence)
		end
		tLVortexCast:Start(self:IsHeroic() and 6 or 8)
		tLVortexDur:Schedule(self:IsHeroic() and 6.01 or 8.01)
		UseSpecial("LV")
		tSpecial:Start(table.concat(SpecialRotation, ", "))
		mSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		wSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		casting = "LightVortex"
		self:Schedule("CastReset", 12, ResetCasting)
	end
end

function mod:DarkTouch(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			local changeEssence = UnitDebuff("player", LightEssence)
			if changeEssence then
				wLight:Show(LightEssence)
			end
		end
	end
end

function mod:LightTouch(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then			
			local changeEssence = UnitDebuff("player", DarkEssence)
			if changeEssence then
				wDark:Show(DarkEssence)
			end
		end
	end
end

function mod:DarkPact(event, args)
	if event == "SPELL_CAST_START" then
		tDPactCast:Start()
	end
end
function mod:LightPact(event, args)
	if event == "SPELL_CAST_START" then
		tLPactCast:Start()
	end
end
function mod:DarkShield(event, args)
	if event == "SPELL_AURA_APPLIED" then
		local target = self:GetCUIDFromUID("playertarget")
		if target ~= 34496 then
			wShield:Show(args.spellName)
		end
		UseSpecial("DS")
		tSpecial:Start(table.concat(SpecialRotation, ", "))
		mSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		wSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		
		showShieldHealthBar(args.dGUID, "Dark Shield")
	
	elseif event == "SPELL_AURA_REMOVED" then
		wInterrupt:Show()
		hideShieldHealthBar()
	end
end
function mod:LightShield(event, args)
	if event == "SPELL_AURA_APPLIED" then
		local target = self:GetCUIDFromUID("playertarget")
		if target ~= 34497 then
			wShield:Show(args.spellName)
		end
		UseSpecial("LS")
		tSpecial:Start(table.concat(SpecialRotation, ", "))
		mSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		wSpecial:Schedule(35, table.concat(SpecialRotation, ", "))
		
		showShieldHealthBar(args.dGUID, "Light Shield")
	
	elseif event == "SPELL_AURA_REMOVED" then
		wInterrupt:Show()
		hideShieldHealthBar()
	end
end

function mod:SPELL_INTERRUPT(event, args)
	if args.extraSpellId == 65876 or args.extraSpellId == 67306 or args.extraSpellId == 67307 or args.extraSpellId == 67308 then -- Light Pact
		tLPactCast:Stop()
		mInteruppt:Show(args.sName)
		
	elseif args.extraSpellId == 65875 or args.extraSpellId == 67303 or args.extraSpellId == 67304 or args.extraSpellId == 67305 then -- Dark Pact
		tDPactCast:Stop()
		mInteruppt:Show(args.sName)
	end
end
